## org.h2.index
Class FunctionIndex

    java.lang.Object
      org.h2.engine.DbObjectBase
          org.h2.schema.SchemaObjectBase
              org.h2.index.BaseIndex
                  org.h2.index.FunctionIndex

All Implemented Interfaces:
  DbObject, Index, SchemaObject

    public class FunctionIndex

extends BaseIndex

An index for a function that returns a result set. This index can only scan through all rows, search is not supported.

Field Summary

Fields inherited from class org.h2.index.BaseIndex
`columnIds, columns, indexColumns, indexType, isMultiVersion, table`

Fields inherited from class org.h2.engine.DbObjectBase
`comment, database, trace`

Fields inherited from interface org.h2.engine.DbObject
`AGGREGATE, COMMENT, CONSTANT, CONSTRAINT, FUNCTION_ALIAS, INDEX, RIGHT, ROLE, SCHEMA, SEQUENCE, SETTING, TABLE_OR_VIEW, TRIGGER, USER, USER_DATATYPE`

Constructor Summary
`FunctionIndex(FunctionTable functionTable, IndexColumn[] columns)`

Method Summary
`void` `add(Session session, Row row)` Add a row to this index.
`boolean` `canGetFirstOrLast()` Check if this index can quickly find the first or last value.
`void` `checkRename()` Check if this object can be renamed.
`void` `close(Session session)` Close this index.
`Cursor` `find(Session session, SearchRow first, SearchRow last)` Create a cursor to iterate over a number of rows.
`Cursor` `findFirstOrLast(Session session, boolean first)` Find the first (or last) value of this index.
`double` `getCost(Session session, int[] masks)` Calculate the cost to find rows.
`long` `getRowCount(Session session)` Get the row count of this table, for the given session.
`long` `getRowCountApproximation()` Get the approximated row count for this table.
`boolean` `needRebuild()` Check if this index needs to be re-built.
`void` `remove(Session session)` Remove the index.
`void` `remove(Session session, Row row)` Remove a row from the index.
`void` `truncate(Session session)` Truncate the index.

Methods inherited from class org.h2.index.BaseIndex
`canFindNext, commit, compareKeys, compareRows, containsNullAndAllowMultipleNull, findNext, getColumnIndex, getColumnListSQL, getColumns, getCostRangeIndex, getCreateSQL, getCreateSQLForCopy, getDropSQL, getDuplicateKeyException, getIndexColumns, getIndexType, getLookupCost, getPlanSQL, getRootPageId, getRow, getTable, getType, removeChildrenAndResources`

Methods inherited from class org.h2.schema.SchemaObjectBase
`getSchema, getSQL, initSchemaObjectBase`

Methods inherited from class org.h2.engine.DbObjectBase
`getChildren, getComment, getDatabase, getId, getModificationId, getName, initDbObjectBase, invalidate, isTemporary, rename, setComment, setModified, setObjectName, setTemporary, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.h2.schema.SchemaObject
`getSchema`

Methods inherited from interface org.h2.engine.DbObject
`getChildren, getComment, getDatabase, getId, getModificationId, getName, getSQL, isTemporary, rename, setComment, setModified, setTemporary`

Constructor Detail

### FunctionIndex

    public FunctionIndex(FunctionTable functionTable,
                         IndexColumn[] columns)

Method Detail

### close

    public void close(Session session)

  Description copied from class: `BaseIndex`
  Close this index.

  Specified by:
    `close` in interface `Index`
  Specified by:
    `close` in class `BaseIndex`
  Parameters:
    `session` - the session

### add

    public void add(Session session,
                    Row row)

  Description copied from class: `BaseIndex`
  Add a row to this index.

  Specified by:
    `add` in interface `Index`
  Specified by:
    `add` in class `BaseIndex`
  Parameters:
    `session` - the session
    `row` - the row to add

### remove

    public void remove(Session session,
                       Row row)

  Description copied from class: `BaseIndex`
  Remove a row from the index.

  Specified by:
    `remove` in interface `Index`
  Specified by:
    `remove` in class `BaseIndex`
  Parameters:
    `session` - the session
    `row` - the row

### find

    public Cursor find(Session session,
                       SearchRow first,
                       SearchRow last)

  Description copied from class: `BaseIndex`
  Create a cursor to iterate over a number of rows.

  Specified by:
    `find` in interface `Index`
  Specified by:
    `find` in class `BaseIndex`
  Parameters:
    `session` - the session
    `first` - the first row to return (null if no limit)
    `last` - the last row to return (null if no limit)
  Returns:
    the cursor to iterate over the results

### getCost

    public double getCost(Session session,
                          int[] masks)

  Description copied from class: `BaseIndex`
  Calculate the cost to find rows.

  Specified by:
    `getCost` in interface `Index`
  Specified by:
    `getCost` in class `BaseIndex`
  Parameters:
    `session` - the session
    `masks` - the condition mask
  Returns:
    the cost

### remove

    public void remove(Session session)

  Description copied from class: `BaseIndex`
  Remove the index.

  Specified by:
    `remove` in interface `Index`
  Specified by:
    `remove` in class `BaseIndex`
  Parameters:
    `session` - the session

### truncate

    public void truncate(Session session)

  Description copied from class: `BaseIndex`
  Truncate the index.

  Specified by:
    `truncate` in interface `Index`
  Specified by:
    `truncate` in class `BaseIndex`
  Parameters:
    `session` - the session

### needRebuild

    public boolean needRebuild()

  Description copied from class: `BaseIndex`
  Check if this index needs to be re-built.

  Specified by:
    `needRebuild` in interface `Index`
  Specified by:
    `needRebuild` in class `BaseIndex`
  Returns:
    true if it must be re-built.

### checkRename

    public void checkRename()

  Description copied from class: `DbObjectBase`
  Check if this object can be renamed. System objects may not be renamed.

  Specified by:
    `checkRename` in interface `DbObject`
  Specified by:
    `checkRename` in class `DbObjectBase`

### canGetFirstOrLast

    public boolean canGetFirstOrLast()

  Description copied from class: `BaseIndex`
  Check if this index can quickly find the first or last value.

  Specified by:
    `canGetFirstOrLast` in interface `Index`
  Specified by:
    `canGetFirstOrLast` in class `BaseIndex`
  Returns:
    true if it can

### findFirstOrLast

    public Cursor findFirstOrLast(Session session,
                                  boolean first)

  Description copied from class: `BaseIndex`
  Find the first (or last) value of this index. The cursor returned is positioned on the correct row, or on null if no row has been found.

  Specified by:
    `findFirstOrLast` in interface `Index`
  Specified by:
    `findFirstOrLast` in class `BaseIndex`
  Parameters:
    `session` - the session
    `first` - true for the first value, false for the last
  Returns:
    a cursor (never null)

### getRowCount

    public long getRowCount(Session session)

  Description copied from interface: `Index`
  Get the row count of this table, for the given session.

  Parameters:
    `session` - the session
  Returns:
    the row count

### getRowCountApproximation

    public long getRowCountApproximation()

  Description copied from interface: `Index`
  Get the approximated row count for this table.

  Returns:
    the approximated row count